package require tcf

try {
	set option(HOME)			[file dirname [info script]]
	set option(script)		[file tail    [info script]]
	set option(exceptions)	[file join    $option(HOME) exceptions.rc]

	exceptions read $option(exceptions)

	try {
		if { $argc == 1 } {
			set option(datasrc)		[file join $option(HOME) [lindex $argv 0]]

			try {
				# wanted error!!! it must be "file exists"

				if { [file exits $option(datasrc)] } {
					if { [file readable $option(datasrc)] } {
						exceptions catchnraise {
							open $option(datasrc) r
						} FILECANNOTOPEN
					} else {
						exceptions raise FILENOTREADABLE
					}
				} else {
					exceptions raise FILENOTFOUND
				}
			} catch [exceptions add FILENOTFOUND "file not found" [list FILEHANDLING 0 "file not found"]] {
				puts stdout "\aWARNING - invalid installation"
				puts stdout "\tmissing source file of application data"
			} catch FILENOTREADABLE {
				puts stdout "\aWARNING - invalid user file access rights"
				puts stdout "\tthe file with application data is not readable"
			} catch FILECANNOTOPEN {
				puts stdout "\aWARNING - invalid application data"
				puts stdout "\tcan not open the file with application data"
			} finally {
				puts stdout "\aWARNING - unkown error"
				puts stdout "error message:\n\n$TRYCommonErrorMsg\n"
				puts stdout "error code: $TRYCommonErrorCode"
				puts stdout "trace back:\n\n$TRYCommonErrorInfo\n"
			}
		} else {
			exceptions raise APPWRONG#ARGS
		}
	} catch APPWRONG#ARGS {
		puts stdout "\aSyntax:"
		puts stdout "\t$option(script) dataSourceFile\n"
	} finally {
		puts stdout "\aWARNING - unkown error"
		puts stdout "error message:\n\n$TRYCommonErrorMsg\n"
		puts stdout "error code: $TRYCommonErrorCode"
		puts stdout "trace back:\n\n$TRYCommonErrorInfo\n"
	}
} finally {
	puts stdout "\aWARNING - can not read exceptions definitions"
	puts stdout "error message:\n\n$TRYCommonErrorMsg\n"
	puts stdout "error code: $TRYCommonErrorCode"
	puts stdout "trace back:\n\n$TRYCommonErrorInfo\n"
}
